/*
	--------------------------------------------------------------------------------
	Web URL:  http://t.qq.com/k1nader
	E-M@IL: mailto: jon.ray@qq.com
	-------------------------------------------------------------------------------- 
*/

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <resocket>

#define PLUGIN	"TSource Engine Query"
#define VERSION	"1.0"
#define AUTHOR	"k1nader"

new AmxxBytes:PacketObj;
new g_iMaxplayers, g_cvarVAC, g_cvarGameDec, g_szMapname[32];
new g_iQueryFid;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	g_cvarVAC = register_cvar("amx_vac", "1");
	g_cvarGameDec = register_cvar("amx_gamedec", "反恐精英");

	g_iMaxplayers = get_maxplayers();
	ReadMapnameList();

	PacketObj = create_packet(); // 创建一个包的对象
	packet_write_int(PacketObj, -1);
	packet_write_string(PacketObj, "TSource Engine Query"); // 给对象写入一个字符串
	g_iQueryFid = register_packet(PacketObj, "QueryFunc"); // 注册一个需要拦截的包
}

public ReadMapnameList() // 读取地图列表
{
	new data_file[128], customdir[64];
	get_customdir(customdir, charsmax(customdir));
	formatex(data_file, charsmax(data_file), "%s/mapnamelist.ini", customdir);
	get_mapname(g_szMapname, charsmax(g_szMapname));

	if (!file_exists(data_file))
	{
		log_amx("Error: can not find mapnamelist.ini.");
		return;
	}

	new File = fopen(data_file, "r");

	new text[256];
	new tempMap[128], left[64], right[64];

	while(File && !feof(File))
	{
		fgets(File, text, charsmax(text));

		if (text[0] == ';')
			continue;

		if (parse(text, tempMap, charsmax(tempMap)) < 1)
			continue;

		trim(tempMap);

		strtok(tempMap, left, charsmax(left), right, charsmax(right), '=');

		if(equal(g_szMapname, left))
			format(g_szMapname, charsmax(g_szMapname), right);
	}
	if (File) fclose(File);
}

public get_botsnum() // 获取BOT数量
{
	new num = 0;
	for (new i = 1; i <= g_iMaxplayers; i++)
	{
		if (is_user_connected(i) && is_user_bot(i))
			num++;
	}
	return num;
}

public make_server_info(AmxxBytes: Info, protocol) // 创建服务器信息的封包
{
	new szHostname[64], szGamename[32], szGameDesc[32], szPassword[32], iPassword, iUseVAC, iPlayernum;
	get_cvar_string("hostname", szHostname, charsmax(szHostname));
	get_cvar_string("sv_password", szPassword, charsmax(szPassword));
	get_modname(szGamename, charsmax(szGamename));

	get_pcvar_string(g_cvarGameDec, szGameDesc, charsmax(szGameDesc));

	if (!strlen(szGameDesc))
		dllfunc(DLLFunc_GetGameDescription, szGameDesc);

	if (!strlen(szPassword))
		iPassword = 0;
	else
		iPassword = 1;

	iPlayernum = get_playersnum(0);
	iUseVAC = get_pcvar_num(g_cvarVAC);

	if (protocol == 48)
	{
		packet_write_int(Info, -1); // 给对象写入一个整形 16 进制为 FF FF FF FF 以下注释忽略，详见：https://developer.valvesoftware.com/wiki/Server_queries#A2S_INFO
		packet_write_byte(Info, 73);
		packet_write_byte(Info, protocol);
		packet_write_string(Info, szHostname);
		packet_write_byte(Info, 0);
		packet_write_string(Info, g_szMapname);
		packet_write_byte(Info, 0);
		packet_write_string(Info, szGamename);
		packet_write_byte(Info, 0);
		packet_write_string(Info, szGameDesc);
		packet_write_byte(Info, 0);
		packet_write_word(Info, 10);
		packet_write_byte(Info, iPlayernum);
		packet_write_byte(Info, g_iMaxplayers);
		packet_write_byte(Info, get_botsnum());
		packet_write_byte(Info, 'd');
		packet_write_byte(Info, 'w');
		packet_write_byte(Info, iPassword);
		packet_write_byte(Info, iUseVAC);
		packet_write_string(Info, "1.1.2.6/Stdio");
		packet_write_byte(Info, 0);
		packet_write_byte(Info, 128);
		packet_write_byte(Info, 135);
		packet_write_byte(Info, 105);
	}
	else if (protocol == 47)
	{
		packet_write_int(Info, -1);
		packet_write_string(Info, "m127.0.0.1:27015");
		packet_write_byte(Info, 0);
		packet_write_string(Info, szHostname);
		packet_write_byte(Info, 0);
		packet_write_string(Info, g_szMapname);
		packet_write_byte(Info, 0);
		packet_write_string(Info, szGamename);
		packet_write_byte(Info, 0);
		packet_write_string(Info, szGameDesc);
		packet_write_byte(Info, 0);
		packet_write_byte(Info, iPlayernum);
		packet_write_byte(Info, g_iMaxplayers);
		packet_write_byte(Info, protocol);
		packet_write_byte(Info, 'd');
		packet_write_byte(Info, 'w');
		packet_write_byte(Info, iPassword);
		packet_write_word(Info, iUseVAC);
	}
}

public QueryFunc(packet[], len, addr[], port)
{
	new AmxxBytes:obj = create_packet(); // 创建一个包的对象

	make_server_info(obj, 47); // 创建 47 协议封包
	send_packet(addr, port, obj); // 发送对象

	clear_packet(obj); // 清空对象

	make_server_info(obj, 48); // 创建 48 协议封包
	send_packet(addr, port, obj); // 发送对象
	free_packet(obj); // 释放对象
	set_packet_block(g_iQueryFid, 1); // 拦截包
}

public plugin_end()
	free_packet(PacketObj); // 释放对象