/*
	--------------------------------------------------------------------------------
	Web URL:  http://t.qq.com/k1nader
	E-M@IL: mailto: jon.ray@qq.com
	-------------------------------------------------------------------------------- 
*/

#include <amxmodx>
#include <amxmisc>
#include <resocket>

#define PLUGIN	"Message Chat"
#define VERSION	"1.0"
#define AUTHOR	"k1nader"

new packet_head[32] = "Message Chat";
new AmxxBytes: PacketObj;
new Array: ServerList;
new g_SayText, g_cvarKey;
new g_iMessageFid;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	g_cvarKey = register_cvar("amx_chat_key", "BAr2t0N");
	register_clcmd("say", "client_say");

	ServerList = ArrayCreate(128);
	read_serverlist();

	g_SayText = get_user_msgid("SayText");

	PacketObj = create_packet();
	packet_write_int(PacketObj, -1);
	packet_write_string(PacketObj, packet_head);
	g_iMessageFid = register_packet(PacketObj, "Message_Func");
}

public read_serverlist()
{
	new data_file[128], customdir[64];
	new tempstr[128];
	
	get_customdir(customdir, charsmax(customdir));
	formatex(data_file, charsmax(data_file), "%s/serverlist.ini", customdir);

	if (file_exists(data_file))
	{
		new File = fopen(data_file, "r");

		new text[256];

		while(File && !feof(File))
		{
			fgets(File, text, charsmax(text));

			if (text[0] == ';')
				continue;

			if (parse(text, tempstr, charsmax(tempstr)) < 1)
				continue;

			trim(tempstr);
			
			ArrayPushString(ServerList, tempstr);
		}
		if (File) fclose(File);
	}
	else
		log_amx("can't find %s", data_file);
	
	if (!ArraySize(ServerList))
	{
		new szKey[64];
		get_pcvar_string(g_cvarKey, szKey, charsmax(szKey));
		
		format(tempstr, charsmax(tempstr), "127.0.0.1:%d=%s", get_cvar_num("hostport"), szKey);
		ArrayPushString(ServerList, tempstr);
	}
}

public find_team(team)
{
	new id = 0, tmpid = 0;
	for (new i = 1; i <= get_maxplayers(); i++)
	{
		if (is_user_connected(i))
		{
			tmpid = id;
			if (get_user_team(i) == team)
			{
				id = i;
				break;
			}
		}
	}
	
	if (!id)
		id = tmpid;
	
	return id;
}

public client_say(id)
{
	new arg[128];
	
	read_args(arg, charsmax(arg));
	remove_quotes(arg);

	trim(arg);
	
	if (strlen(arg))
	{
		if (arg[0] == '!')
		{
			format(arg, charsmax(arg), arg[1]);
			trim(arg);
			if (strlen(arg))
			{
				new szName[32], ServerInfo[128], left[64], right[64], ip[32], port[32], iTeam, AmxxBytes: msg_bytes;
				get_user_name(id, szName, charsmax(szName));
				iTeam = get_user_team(id);

				for (new i = 0; i < ArraySize(ServerList); i++)
				{
					ArrayGetArray(ServerList, i, ServerInfo);
					strtok(ServerInfo, left, charsmax(left), right, charsmax(right), '=');
					strtok(left, ip, charsmax(ip), port, charsmax(port), ':');
					msg_bytes = create_packet();
					packet_write_int(msg_bytes, -1);
					packet_write_string(msg_bytes, packet_head);
					packet_write_byte(msg_bytes, iTeam);
					packet_write_string(msg_bytes, szName);
					packet_write_byte(msg_bytes, 0);
					packet_write_string(msg_bytes, arg);
					packet_write_byte(msg_bytes, 0);
					packet_write_string(msg_bytes, right);
					send_packet(ip, str_to_num(port), msg_bytes);
					free_packet(msg_bytes);
				}

				return PLUGIN_HANDLED;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public Message_Func(packet[], len, addr[], port)
{
	new iTeam, iLen, msg_Len, szName[32], szKey[64], szcvarKey[64], szReadMessage[64], szMessage[128];

	iLen = strlen(packet_head);
	iTeam = packet[iLen];
	iLen += 1;
	format(szName, charsmax(szName), packet[iLen]);
	iLen += strlen(szName) + 1;
	format(szReadMessage, charsmax(szReadMessage), packet[iLen]);
	iLen += strlen(szReadMessage) + 1;

	if (len - iLen > charsmax(szKey))
		msg_Len = charsmax(szKey);
	else
		msg_Len = len - iLen;

	format(szKey, msg_Len, packet[iLen]);
	get_pcvar_string(g_cvarKey, szcvarKey, charsmax(szcvarKey));

	if (equal(szKey, szcvarKey))
	{
		format(szMessage, charsmax(szMessage), "^1* ^4(全服)^3 %s^1 : %s", szName, szReadMessage);

		if (get_playersnum(1) > 0)
			client_color(0, find_team(iTeam), szMessage);
	}
	
	set_packet_block(g_iMessageFid, 1);
}

stock client_color(index, color, const msg[])
{
	message_begin(index ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, g_SayText, _, index);
	write_byte(color ? color : print_chat);
	write_string(msg);
	message_end();

	client_print(index, print_console, msg);
}

public plugin_end()
{
	ArrayDestroy(ServerList);
	free_packet(PacketObj);
}