/*
	--------------------------------------------------------------------------------
	Web URL:  http://t.qq.com/k1nader
	E-M@IL: mailto: jon.ray@qq.com
	-------------------------------------------------------------------------------- 
*/

#include <amxmodx>
#include <amxmisc>
#include <resocket>

#define PLUGIN	"Rcon password Fix"
#define VERSION	"1.0"
#define AUTHOR	"k1nader"

new AmxxBytes: CmdRconPacket;
new Trie: g_TrieRcon;
new g_iCmdFid;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	CmdRconPacket = create_packet();
	packet_write_int(CmdRconPacket, -1);
	packet_write_string(CmdRconPacket, "rcon");
	g_iCmdFid = register_packet(CmdRconPacket, "rcon_func");

	g_TrieRcon = TrieCreate();
}

public rcon_func(packet[], len, addr[], port)
{
	new bool:BadPassword = true;

	if (strlen(packet) > 4)
	{
		new szPacket[512], iPos;
		copy(szPacket, charsmax(szPacket), packet[4]);

		iPos = contain(szPacket, " ");

		if (iPos != -1)
		{
			iPos += 1;
			copy(szPacket, charsmax(szPacket), szPacket[iPos]);

			iPos = contain(szPacket, " ");
			
			if (iPos != -1)
			{
				iPos += 2;
				copy(szPacket, charsmax(szPacket), szPacket[iPos]);

				iPos = contain(szPacket, "^"");

				if (iPos != -1)
				{
					copy(szPacket, iPos, szPacket);
					new szRconPassword[512];
					get_cvar_string("rcon_password", szRconPassword, charsmax(szRconPassword));

					if (equal(szRconPassword, szPacket))
						BadPassword = false;
				}
			}
		}
		
	}

	if (BadPassword)
	{
		new szKey[32];
		format(szKey, charsmax(szKey), "%s:%d_BadCout", addr, port);

		if (TrieKeyExists(g_TrieRcon, szKey))
		{
			new badcout[32], failures;
			TrieGetString(g_TrieRcon, szKey, badcout, charsmax(badcout));
			failures = str_to_num(badcout);
			if (failures >= get_cvar_num("sv_rcon_minfailures"))
			{
				TrieDeleteKey(g_TrieRcon, szKey);
				server_cmd("addip %d %s", get_cvar_num("sv_rcon_banpenalty"), addr);
			}
			else
			{
				failures++;
				num_to_str(failures, badcout, charsmax(badcout));
				TrieSetString(g_TrieRcon, szKey, badcout);
			}
		}
		else
			TrieSetString(g_TrieRcon, szKey, "1");

		new AmxxBytes: SendRepot;

		SendRepot = create_packet();
		packet_write_int(SendRepot, -1);
		packet_write_string(SendRepot, "l错误的RCON密码。");
		send_packet(addr, port, SendRepot);
		free_packet(SendRepot);

		server_print("%s:%d - Bad rcon_password.", addr, port);
		set_packet_block(g_iCmdFid, 1);
	}
}

public plugin_end()
{
	free_packet(CmdRconPacket);
	TrieDestroy(g_TrieRcon);
}